<template>
  <q-table
    :class="{fullscreen: isFullscreen}"
    class="scrollWrapper"
    table-class="tableWrapper"
    :data="orders"
    :columns="head"
    hide-bottom
    :virtual-scroll="isFullscreen"
    @virtual-scroll="setCellStickyLeft(true)"
  >
    <template #top v-if="isFullscreen">
      <CCol>
        <span
          class="toggleFullScreen"
          @click="setIsFullScreen"
        >
          Свернуть таблицу
        </span>
      </CCol>
    </template>
    <template #body-cell="props">
      <q-td :props="props">
        <div class="tableHeadInner">
          <template v-if="props.col.doubleCell">
            <p class="mainInfo">{{props.value[0]}}</p>
            <p class="doubleInfo">{{props.value[1]}}</p>
          </template>
          <template v-else>
            {{ props.value }}
          </template>
        </div>
      </q-td>

    </template>
  </q-table>
</template>

<script>
  export default {
    name: "OrdersTable",
    props: {
      data: {
        type: Array,
        default() {
          return [];
        }
      },
      head: {
        type: Array,
        default() {
          return [];
        }
      },
      isFullscreen: {
        type: Boolean,
        default: false,
      },
    },
    computed: {
      orders() {
        return this.data.map(order => {
          const {
            id, created_at, supplier_name, not_assigned_manager, legal_entity_name, platform_name,
            total_price, deviation, next_order_date
          } = order;
          const {name} = order.user;
          const deviationPercentage = (deviation + 1) * 100 / total_price > 10 ? 'Отклонение > 10%' : 'Отклонение < 10%'
          return {
            order: [`№ ${id}`, `от ${created_at}`],
            supplier: [supplier_name, not_assigned_manager],
            legalEntityName: legal_entity_name,
            platform: platform_name,
            manager: name,
            totalPrice: [total_price, deviationPercentage],
            nextOrderDate: next_order_date,
          }
        })
      }
    },
    watch: {
      data() {
        setTimeout(() => this.setCellStickyLeft(), 0);
      }
    },
    methods: {
      setIsFullScreen() {
        this.$emit('setFullScreenTable', false);
        this.$nextTick(() => this.setCellStickyLeft(false));
      },
      setCellStickyLeft(isVirtualScroll) {
        console.log('setCellStickyLeft');
        const tbody = isVirtualScroll ? '.q-virtual-scroll__content' : 'tbody';
        const tdArray = this.$el.querySelectorAll(`.tableWrapper > table > ${tbody} > tr > td`);
        const thArray = this.$el.querySelectorAll('.tableWrapper > table > thead > tr > th');
        const td0Width = tdArray[0].offsetWidth;
        const td1Width = tdArray[1].offsetWidth;
        thArray[1].style.left = td0Width + 'px';
        thArray[2].style.left = td0Width + td1Width + 'px';
        tdArray.forEach((td, index) => {
          if (index - 1 === 0 || (index - 1) % 7 === 0) {
            td.style.left = td0Width + 'px';
          } else if (index - 2 === 0 || (index - 2) % 7 === 0) {
            td.style.left = td0Width + td1Width + 'px';
          }
        })
      }
    }
  }
</script>
